#!/opt/csw/bin/perl

use CGI qw(:standard escapeHTML);
use LWP::UserAgent;
use HTTP::Request;
use HTTP::Response;
use URI::Heuristic;
use IO::File;
use POSIX qw(tmpnam);
use Time::localtime;

use strict;

my $rank=param("selRank");
my $url=param("selUrl");
my $name1;
my $name2;

my $script_name;
my $query=new CGI;
my $TITLE = "EstSum demo";
my $path_info = $query->path_info;
      print $query->header;
      if (!$path_info) {
        &print_frameset;
        exit 0;
      }
      &print_html_header;
      &print_query if $path_info=~/query/;
      &print_response if $path_info=~/response/;
      &print_end;

sub print_frameset{
   $script_name= $query->script_name;
   print <<EOF;
<html><head><title>$TITLE</title></head>
<frameset rows="25%,75%">
<frame src="$script_name/query" name="query">
<frame src="$script_name/response" name="response">
</frameset>
EOF
    ;
    exit 0;
}

sub print_html_header {
    print $query->start_html($TITLE);
}

sub print_end {
    print $query->end_html;
}
sub print_query {
  unless ($url){
    $script_name = $query->script_name;
    print "<H1>Automaatse sisukokkuv&otilde;tja EstSum demo</H1>\n";

    print $query->startform(-action=>"$script_name/response",-TARGET=>"response");
    print $query->p("Anna url:  ",
                    $query->textfield(-name => "selUrl", -size => 80), 
                    "Vali kokkuvtte protsent: ", 
                    $query->popup_menu('selRank',[qw(10 20 30 40 50)]),
                    $query->submit('showInput', 'Kokkuvte'));
    print $query->endform;
  }
}

sub print_response {
    print "<H1>Kokkuv&otilde;te</H1>\n";
    unless ($query->param) {
	print "<b>Vali Postimees Online artikli url. V&otilde;ib proovida ka Valgamaalast, Sakalat, J&auml;rva Teatajat jt ning &Otilde;htulehte ja Delfit.</b>";
	print "<P><br>Teiste portaalide teisendaja valmib varsti.</p>";
	print "<P><br>Ootan kommentaare, mtteid, ettepanekuid kaili t ut.ee</p>";
	print "<P><font size=\"-1\">Sisukokkuvtja td on kirjeldatud artiklis K. Mrisep <a href=\"http://uuslepo.it.da.ut.ee/~kaili/papers/myyrisepsisukokku.pdf\">Eestikeelsete tekstide sisukokkuvtjast EstSum</a>.</P> In Keel ja arvuti. Tartu likooli ldkeeleteaduse ppetooli toimetised 6.(Toim. M. Koit, R. Pajusalu, H. im) Tartu 2006. lk 115-125.</font>";
	return;
    }
    $url=URI::Heuristic::uf_urlstr($url);
    my $ua= LWP::UserAgent->new();
    $ua->agent("Summizilla/v0.01 Platinum");
    my $req = HTTP::Request->new(GET=>$url);
    $req->referer("http://www.cs.ut.ee/~kaili/estsum/");
    my $response = $ua->request($req);
    if ($response->is_error()){
       print $query->p($response->status_line);
    } else {
#      print $query->p($response->title);
#      print "<SCRIPT> window.open('",$url,"', 'Test', 'width=600,height=400');</SCRIPT>";
      print $query->p();
      filter($response->content);
    }
    open (LOG, ">>estsumlogi") or die "unable: $!\n";
    print LOG "> $url\n";
    close(LOG);
    #print "</html>";
}


BEGIN
{
  use CGI::Carp qw(carpout);
  open (LOG, ">>estsumlogi") or die "unable: $!\n";
#  $tm=localtime;
#  print "$tm->mday.$tm->mon.$tm->year :";
#  print LOG "$url\n";
  carpout(*LOG);
}

sub filter {
my $fh1;
my $fh2;
my $status;
my $program="./demoestsum.sh";
my $line;

  do { $name1= tmpnam(); }
  until $fh1 = IO::File->new($name1, O_RDWR|O_CREAT|O_EXCL) ;
  print $fh1 $_[0];
  do { $name2= tmpnam(); }
  until $fh2 = IO::File->new($name2, O_RDWR|O_CREAT|O_EXCL) ;
  $status = system($program, $name1, $name2, $rank);
  die "$program exited: $?" unless $status == 0;
  while (defined($line = $fh2->getline())){
     print $line;
  }

}

END { 
  unlink($name1) or die "Couldn't unlink $name1 : $!";
  unlink($name2) or die "Couldn't unlink $name2 : $!"; 
}

