#!/opt/csw/bin/perl -w

use HTML::Parser;

###############################################################
# HTML-i teisendamisega tegelev osa
###############################################################

my $p = HTML::Parser->new(api_version => 3);
$p->handler(text => \ &textHandler, "self, text");
$p->handler(start => \ &startHandler,"self, tagname, attr, attrseq, text");
$p->handler(end => \ &endHandler,"self, tagname, text");
$p->handler(default => "");
$p->unbroken_text(1);

my $kustuta=1;
my $tabelis=0;
my $delfisisus=0;
my $delfifont=0;
my $dlefikriips=0;

sub textHandler{
  my($self, $otext) = @_;
  $otext =~ tr/\t/ /;
  $otext =~ tr/\n/ /;
  $otext =~ tr/\0-\37//d;
  $otext =~ tr/\x7f//d;
  $otext =~ tr/\x85/.../;
  $otext =~ tr/\x86-\x87/*/;
  $otext =~ tr/\x8B/`/;             
  $otext =~ s/\x8F/&cedil;/g;
  $otext =~ tr/\x91-\x92/'/;
#  $otext =~ tr/\x93-\x94/"/;
  $otext =~ tr/\x95/x2a/; # bullet -> asterisk
  $otext =~ tr/\x96-\x97/-/;
  $otext =~ s/\x99/TM/g;
  $otext =~ tr/\x9B/'/;
#  $otext =~ tr/\x9E/*/;
  $otext =~ s/«+/"/g;
  $otext =~ s/»+/"/g;
  $otext =~ s/”+/"/g;
  $otext =~ s/„+/"/g;
  $otext =~ s/„/"/g;
  $otext =~ s/“+/"/g;
  $otext =~ s/""/"/g;
  $otext =~ tr/–/-/;
  $otext =~ s/\xE2/"/g;
  $otext =~ s/\x80/"/g;
  $otext =~ s/\x9D/"/g;
  $otext =~ s/\x9C/"/g;
  $otext =~ s/\x9E/"/g;
  $otext =~ s/\x9F/"/g;
  $otext =~ s:&nbsp;: :g; 
  $otext =~ s/\n/ /g;
  $otext =~ s/\r//g;
  $otext =~ s/\s+/ /g;
  $otext =~ s/^\s+//g ;
 # $otext =~ s/&\#8220;/\xAB/g;
 # $otext =~ s/&\#8221;/\xBB/g;
  print $captiontext if ($caption);
  print "<hi rend='bold'>" if ($bold &&!$kustuta);
  print "$otext " unless ($kustuta);
  print "</hi> " if ($bold && !$kustuta);
}

sub startHandler{
  my($self, $tagname, $attr, $attrseq, $otext) = @_;

  if ($tagname eq "span"){
    if (exists $attr->{id}){
      if ($attr->{id} eq "lisa_allkirja_kast"){
         #$caption=1;
         #$captiontext="Pildi allkiri: ";
         #$kustuta =0; 
      }
    }
    if (exists $attr->{class}){
      if ($attr->{class} eq "author"){
         print "<bibl><author>";
         $author=1; $kustuta=0;
      }
    }
  }
  if ($tagname eq "a"){
    if (exists $attr->{class}){
      if ($attr->{class} eq "comment"){
         $kustuta =1; 
      }
    }
  }

  if ($tagname eq "h1") {
   # if (exists $attr->{id}){
   #   if ($attr->{id} eq "artikli_pealkiri"){                 #postimehe pealkiri
   #     print "\n<div0 type='unknown'><head>";
   #     $kustuta = 0;
   #   }       
   # }
    if (exists $attr->{class}){
      if ($attr->{class} eq "art_pealkiri"|| $attr->{class} eq "artikli_pealkiri" ){                 #postimehe pealkiri
        print "\n<div0 type='unknown'><head>";
        $kustuta = 0;
      }       
      if ($attr->{class} eq "TextTitle_Artiklisees"){                 #postimehe pealkiri
        print "\n<div0 type='unknown'><head>";
        $kustuta = 0;
      }       
    } else { #õhtuleht? #delfi
        print "\n<div0 type='unknown'><head>";
        $kustuta = 0; #$sloleht=1;  
    }
  }
 if ($tagname eq "meta"){
   if (exists $attr->{content}){ 
     if ($attr->{content} =~ /htuleht/){
        $sloleht =1;
     }
     if ($attr->{content} =~ /DELFI/){
        $delfi =1;
     }

   }
 }
 if ($tagname eq "strong"){
     if ($sloleht){
       $bold = 1; #$kustuta=0;
     }
     else{ 
        print "\n<div1 type='unknown'><head>";
        $kustuta = 0; $heading=1;
     }
 } 
 if ($tagname eq "div") {
    if (exists $attr->{id}){
      if ($attr->{id} eq "artikli_sissejuhatus"){         #boldis esimene lõik
        $bold=1;
        $kustuta = 0;
        print "<p> "; $par++;
      }
      if ($attr->{id} eq "teema_algatamine"){         #õhtulehe kommentaarid algavad
        $kustuta = 1; exit;
      }
    }
    if (exists $attr->{class}){   
      if ($attr->{class} eq "artikkel_tykid"){                #sisu
        $kustuta = 0;
        print "<p> "; $par++;
      }           
      if ($attr->{class} eq "uudisplokk"){                #allpoolne jama
        exit;
      }           
      if ($attr->{class} eq "clearer"){                #allpoolne jama
        $kustuta=1;
      }           
      if ($attr->{class} eq "hr"){                #allpoolne jama
        $delfikriips++;
        if ($delfikriips >1) {exit;}
      }           

    }
 }
  if ($tagname eq "p"){
    if (exists $attr->{style}){   
      if ($attr->{style} =~ /line-height: 15px;/){                #sisu
        $kustuta = 0;
        print "<p> "; $par++;
      }           
    } else { if ($tpm || $sloleht){
        $kustuta = 0;
        print "\n<p> "; $par++;}
    }
  }
  if ($tagname eq "td"){
    if (exists $attr->{class}){   
      if ($attr->{class} =~ /Text10px/){                #pildi allkiri
        $kustuta = 1; $tpm =1;
        #print "<p> "; $par++;
      }           
      if ($attr->{class} =~ /BackSkyBlue/){                #kommentaarid
        $kustuta = 1;
        #print "<p> "; $par++;
      }           
    }
  }
  if ($tagname eq "font") {
    if (exists $attr->{class}){ 
     if ($attr->{class} =~ /articleBody/){                #delfi sisu
       $kustuta=0;$delfisisus=1;$delfifont=1;print "</p>\n<p>";
     }
     elsif ($delfifont) {$delfifont++;}
     if ($attr->{class} =~ /relatedT/){                #delfi vaata teisi
       exit;
     }
    }
  }
  if ($tagname eq "style") {
    if (exists $attr->{type}){ 
     if ($attr->{type} =~ /text.css/){                #delfi css
       $kustuta=1;
     }
    }
  }
  if ($tagname eq "br"){
    print "</p>\n<p> " unless ($heading);
  } 
 
  if ($tagname eq "table"){
    if (exists $attr->{class}){ 
     if ($attr->{class} =~ /ABouter/){                #delfi css
      $kustuta=1; $tabelis=1;
     }
     elsif ($tabelis) {
       $tabelis++;
     }
    }
  }
}

sub endHandler{
  my($self, $tagname, $otext) = @_;
  if ($tagname eq "div") {
    $kustuta=1;$bold=0;
    if ($par) {
      print "</p>\n";
      $par--;
    }
  }
  if ($tagname eq "span") {
    if ($author){ 
      print "</author></bibl>\n";
      $author=0;
    } else {
      $caption=0;
      $kustuta=1;
    }
  }
  if ($tagname eq "h1") {print "</head>\n"; $kustuta=1;}
  if ($tagname eq "p"){
    if ($sloleht){
      print "</p>\n";
    }
  }
  if ($tagname eq "strong"){
    if ($sloleht){$bold=0;}
    else {
        print "</head>\n"; $heading=0;
    }
  }
  if ($tagname eq "style"){
    if ($delfi && $delfisisus){$kustuta=0;}
  } 
  if ($tagname eq "font"){
    if ($delfifont){$delfifont--;}
    if ($delfi && $delfifont==0){$kustuta=1;$delfisisus=0}
  } 

  if ($tagname eq "table"){
   if ($tabelis) {$tabelis--;}
   if ($tabelis == 0 && $delfisisus) {$kustuta=0;}
  }

}


##################################################################
# main
##################################################################
$p->parse_file(shift || die) || die $!;


 
