#!/usr/bin/perl -w

use Getopt::Std;

$PROTSENT = 0.3; #mitu protsenti sisukokkuvõtja ekstraktib
$POSSC = 0.2;	#positsiooniskoori osakaal
$FORSC = 0.3;	#formaadiskoori osakaal
$WRDSC = 0.5;	#sõnade sageduse osakaal

my $collect = 0;	#lipuke
my ($article, $sentence);
my $parnr = 0;	#lõigu nr
my $divnr = 0;	#divi nr
my @keywords = ();

getopts("p:");
#print $opt_p;
if ($opt_p){
  $PROTSENT = $opt_p/100;
  #print $PROTSENT, "\n";
} 
else {die "Jama";}
while(<> ){
   
  if (m/<div0/){	#artikli pealkiri	
    init_article();	#algväärtustamine
    
    tiitel($_);		#pealkirjast sõnade uurimine
    print;
    $collect = 1;	#hakka lauseid koguma
    next;
  }
  if (m/\/div0/){	#artikli lõpp
    $collect = 0;
   
    print_annotation();	#trüki kokkuvõte
    print "\n";
    next;
  }
  if ($collect){	#artikli sees
    put_line($_);	#töötle rida
    next;
  }

#####################################################################
sub init_article{
  #general init
  $article = { "wcount" => 0,	#sõnad
              "scount" => 0,	#laused
              "pcount" => 0,	#lõigud
              "divcount" => 0,	#divid
              "title"  => "",	#pealkiri
              "tlength" => 0,	#pikkus
              "body"   => [],	#artikli sisu
              "sort"  => [],	#sorteeritult
            };
  #position-specific init
  $parnr = 0;
  $divnr = 0;
  #word-specific init
  %words = ();
 
}
##################################################################
sub tiitel{
  my $tc=0;
  $article->{"title"} = $_[0];
  $article->{"scount"}++;	#lausete arv ++
  my $rida = $_[0];
  $rida =~ s:<[^>]*>::g;
  my @abi=split(/[\s,.?!:\xAB\xBB\-\";\(\)]+/,$rida); #semikoolon välja
  #words of title are valuable
  foreach $w (@abi) {
    #print $w, " ";
    if ($w !~ /^\s*$/){
      $words{lc($w)}+=5;	#pealkirja sõnad saavad 5-kordse kaalu
      $tc++;
    }
  }   
  $article->{"tlength"} = $tc;	#pealkirja sõnade arv
  $article->{"wcount"} += $article->{"tlength"};

   #foreach $k (keys %words){print $k, " ";} #komm!
}
##################################################################
sub put_line{
  if (m/<p>/){
    $article->{"pcount"}++;
    ++$parnr;
    return;
  }
  return if (m/<\/p>/ || m/<\/div/);
  $sentence = { "wcount" => 0,	#init lause
                "parnr" => 0,
                "divnr" => 0,
                "subhead" => 0,
                "bibl" => 0,
                "caption" => 0,
                "possc" => 0,
                "forsc" => 0,
                "wrdsc" => 0,
                "score"  => 0,
                "content" => "",
               }; 
  my $rida = $_[0];
  if ($rida =~ /<div/){                     #kui on alampealkiri
                                            #aga ei järgne vahetult pealkirjale
    if (scalar(@{$article->{"body"}}) != 0){
      $article->{"divcount"}++;
      ++$divnr;
    }   
    $sentence->{"subhead"} = 1;
                                           # pealkiri on eraldi lõik
    $article->{"pcount"}++;
    $parnr++;
                                            #kustuta div-märgendid
    $rida =~ s:<div\d[^>]*><head>(.*)</head>:$1:g;
  }
  if ($rida =~ /<bibl>/){
     $sentence->{"bibl"} = 1;
  }
  if ($rida =~ /Pildi allkiri/){
     $sentence->{"caption"} = 1;
  }
  $sentence->{"content"} = $rida;
  $sentence->{"parnr"} = $parnr;
  $sentence->{"divnr"} = $divnr;
  $rida =~ s:<[^>]*>::g;
  my @abi=split(/[\s,.!?;:\xAB\xBB\-\"\(\)]+/,$rida);
  $sentence->{"wcount"} += scalar(@abi);
  my $weight=1;
  if ($sentence->{"subhead"}) {
     $weight++;
  }
  foreach $w (@abi) {
    $ww= lc($w);
    if ($ww =~ /^[a-zõäöü]+/){
    $words{$ww}+=$weight;}# else {print ">$rida\n";}
  }
  push @{$article->{"body"}}, $sentence;
  $article->{"wcount"} += $sentence->{"wcount"};
}
##################################################################
sub print_annotation{

  my $summlength = calc_sum_length($article->{"wcount"});
  my $lipp = 0;
  $i=1;
  score();

 # my $sc = sprintf("%.6f",min_score($summlength));
  my $sc = min_score($summlength);
#  print "--> ",$sc, " <---\n";
  my $lastpar = 0;
  my $actuallength = $article->{"tlength"};

  #@sonad=sort { $words{$b}<=> $words{$a}} keys %words; #komm!
  #for ($i=0; $i<=20 && $i<= $#sonad; $i++){print $sonad[$i], "\n";} #komm!
  print "##################\n";
  foreach $elem (@{$article->{"body"}}){
    if ($elem->{"score"}+0.00001 >= $sc && $actuallength <= $summlength){
#   if ($elem->{"score"}+0.0001 >= $sc) {# && $actuallength <= $summlength){
      if ($elem->{"parnr"} > $lastpar){
         if ($lipp) {print "</p>\n<p>\n";}
         else {print "<p>\n";}
         $lastpar = $elem->{"parnr"};
      }
      printf("%d. p=%f f=%f w=%f s=%f\t",$i++,
            $elem->{"possc"},$elem->{"forsc"}, $elem->{"wrdsc"},$elem->{"score"});
      print $elem->{"content"};
      $actuallength += $elem->{"wcount"};
      $lipp = 1;
    }else{ $i++;}
  }
  print "##################\n";
  print "Kokkuvõte koosneb ", $actuallength, " sõnast.\n";
  print "Plaaniti ", $summlength, " sõna.\n";
  print "Artiklis oli ", $article->{"wcount"};
  print "\n10 võtmesõna: ";
  $i=0;
  foreach $item (@keywords) {
    print "\"$item\" "; $i++;
    last if ($i==10);
  }
}
#########################################################################
sub score{
  position_based_score();
  format_based_score();
  word_based_score();
  foreach $elem (@{$article->{"body"}}){
    if ($elem->{"subhead"}) {$elem->{"score"}=0;}
    else{
    $elem->{"score"} = $POSSC*$elem->{"possc"} + $FORSC*$elem->{"forsc"} 
                       + $WRDSC*$elem->{"wrdsc"};
    }
    }
}
#########################################################################
# postion_based score
#########################################################################
sub position_based_score{
  my $i=1; #number of sentence in the article
  my $j=1; #number of sentence in the paragraph
  my $k=1; #number of sentence in div  
  my $lastparnr = 0; #last observed paragraph number
  my $lastdivnr = -1; #last observed division number

  foreach $elem (@{$article->{"body"}}){
    if ($elem->{"parnr"} > $lastparnr){
      $lastparnr = $elem->{"parnr"};
      $j=1;
    }
    if ($elem->{"divnr"} > $lastdivnr){
      $lastdivnr = $elem->{"divnr"};
      $k=1;
      #print "\t",$elem->{"content"}; 
    }
                            
#lõigus esimesed laused
    if ($i == 1 && $elem->{"content"} !~ /Pildi allkiri/){
         $elem->{"possc"} += 20;
    }
    if ($j == 1 && !$elem->{"subhead"}){
         $elem->{"possc"} += 5;
    }
#divi 2. lause ehk artikli 1.
    if ($k == 2 && $i!= 2){
         $elem->{"possc"} += 5;
    }
#ei tea
    if ($i == 2){
         $elem->{"possc"} += 5;
    } 
#lõigu teine lause
    if ($j == 2) {
         $elem->{"possc"} += 2;
    }
#lõigu 3. lause
    if ($j == 3) {
         $elem->{"possc"} += 1;
    } 
    $i++;
    $j++;
    $k++;
  }   
 norm_position_score();
}
###########################################################################
sub norm_position_score{
  my $total = 0;
  foreach $elem (@{$article->{"body"}}){
     $total += $elem->{"possc"};
  }
  foreach $elem (@{$article->{"body"}}){
     $elem->{"possc"} = sprintf("%.6f",$elem->{"possc"}*100/$total);
  }
} 
###########################################################################
# format_based score
# tavaline tekst +1, bold +15, ? või ! lause lõpus -1, 
# ? või ! ja </hi> lause lõpus -16, jutumärgid -1.
###########################################################################
sub format_based_score{
  foreach $elem (@{$article->{"body"}}){
     $elem->{"forsc"} = 5;
     $elem->{"forsc"} += 8 if ($elem->{"content"} =~ m:<s><hi .*</hi></s>:);
     $elem->{"forsc"} -= 5 if ($elem->{"content"} =~ m:[!\?]+</s>:); 
     $elem->{"forsc"} -= 13 if ($elem->{"content"} =~ m:[!\?]+</hi></s>:);
     $elem->{"forsc"} -= 5 if ($elem->{"content"} =~ m:[!\?]+:);
     $elem->{"forsc"} -= 4 if ($elem->{"content"} =~ m:\":); 
     $elem->{"forsc"} -= 13 if ($elem->{"content"} =~ m:[!\?]+\":);     
     $elem->{"forsc"} = 0 if ($elem->{"subhead"}||$elem->{"bibl"}||$elem->{"caption"});
     $elem->{"forsc"} -= 4 if ($elem->{"content"} =~ m:<s>\xAB[^\xBB]*,\xBB:);
     $elem->{"forsc"} -= 4 if ($elem->{"content"} =~ m:<s>\xAB[^\xBB]*\xBB</s>:);
     $elem->{"forsc"} -= 4 if ($elem->{"content"} =~ m:\: \xAB[^\xBB]*\xBB</s>:);
     
     $elem->{"forsc"} = 0 if ($elem->{"forsc"} < 0);
     $elem->{"forsc"} = 0 if ($elem->{"content"} =~ m:<bibl>:);
     $elem->{"forsc"} = 0 if ($elem->{"wcount"} <=3);
  }
  norm_format_score();
}
###########################################################################
sub norm_format_score{
  my $total = 0;
  foreach $elem (@{$article->{"body"}}){
     $total += $elem->{"forsc"};
  }
  if ($total==0) {$total++;}
  foreach $elem (@{$article->{"body"}}){
     $elem->{"forsc"} = sprintf("%.6f",$elem->{"forsc"}*100/$total);
  }
} 
###########################################################################
sub word_based_score{
  my @abi;
  my $rida;
 
  norm_word_weights();
  foreach $elem (@{$article->{"body"}}){
    $rida =  $elem->{"content"};
    $rida =~ s:<[^>]*>::g;
    @abi = split(/[\s,.?!;:\xAB\xBB\-\"\(\)]+/,$rida);
    foreach $w (@abi){
      if (exists($words{$w})){ 
        $elem->{"wrdsc"}+=$words{$w};
      }
    }
    if ($elem->{"wcount"}!=0) {
      $elem->{"wrdsc"} /= $elem->{"wcount"}; 
    }
    else {
      $elem->{"wrdsc"} = 0; 
    }

  }
  norm_word_score();
}
###########################################################################
sub norm_word_score{
  my $total = 0;
  foreach $elem (@{$article->{"body"}}){
     $total += $elem->{"wrdsc"};
  }
  if ($total==0) {$total++;}
  foreach $elem (@{$article->{"body"}}){
     $elem->{"wrdsc"} = sprintf("%.6f",$elem->{"wrdsc"}*100/$total);
  }
} 
###########################################################################
sub norm_word_weights{
  open(FREQ, "< sagedusutf.tab")
    or die "Couldn't open sagedus.tab for reading: $!\n";
  %nwords=();
  while (<FREQ>){
    ($wrd, $frq) = m/(\S+)\t(\d+)/;
    $nwords{lc($wrd)} = $frq;
  }
  close(FREQ);
  open(BLACK, "< blacklist.tab")
    or die "Couldn't open blacklist.tab for reading: $!\n";
  while (<BLACK>){ 
     chomp;
     $blacklist{$_}++;
  }
  close(BLACK);

  $x=10000/$article->{"wcount"};
  foreach $w (keys %words){
    if (exists($blacklist{$w})){
       $words{$w}=0; next;
    }
    if ($w =~ /\s+/) {$words{$w}=0; next;} 
    $words{$w} = sprintf("%.2f",$words{$w} * $x);
    if (exists($nwords{$w})){
           if ($words{$w} - $nwords{$w} > 0)   
             { $words{$w}-=$nwords{$w};} 
           else {$words{$w}=0;}
    } 
  }


  @keywords= sort {$words{$b}<=>$words{$a}} (keys %words);

  
}
###########################################################################
sub min_score{
  $sl = $_[0];
  $sl -= $article->{"tlength"};
  # print "Vaja on: ", $sl, "\n";
  $sl += 10;   # % more
  if ($sl < 0) {return 10000;} 
  my $min = 100000;
 
  %scores=();
  foreach $elem (@{$article->{"body"}}){
    $scores{$elem->{"score"}}+=$elem->{"wcount"};
  }
  foreach $s (sort {$b <=> $a} keys %scores){
   #print $s, "\t", $scores{$s}, "\n"; 
    if ($scores{$s} < $sl){
      $min = $s;
      $sl -= $scores{$s};
    }
    else { last; } 
  }
  print "Min score. ", $min, "\n";
  return $min;
}
###########################################################################     
sub calc_sum_length{
  return int($PROTSENT*$_[0]);
} 
#  print; 
}
